﻿Imports Microsoft.VisualBasic
Imports System.IO.Ports

Public Class Form1
    Public Declare Function FT_OpenByDescription Lib "FTD2XX.DLL" _
    Alias "FT_OpenEx" (ByVal Description As String, _
    ByVal lngFlags As Integer, _
    ByRef lngHandle As Integer) As Integer 'Neu Kulraj FTDI April 2010

    Public Declare Function FT_Close Lib "FTD2XX.DLL" ( _
    ByVal lngHandle As Long) As Long

    Public Declare Function FT_SetBreakOn Lib "FTD2XX.DLL" ( _
    ByVal lngHandle As Long) As Long

    Public Declare Function FT_SetDtr Lib "FTD2XX.DLL" ( _
    ByVal lngHandle As Long) As Long

    Public Declare Function FT_ClrDtr Lib "FTD2XX.DLL" ( _
    ByVal lngHandle As Long) As Long

    Public Declare Function FT_SetRts Lib "FTD2XX.DLL" ( _
    ByVal lngHandle As Long) As Long

    Public Declare Function FT_ClrRts Lib "FTD2XX.DLL" ( _
    ByVal lngHandle As Long) As Long

    Public Declare Function FT_GetModemStatus Lib "FTD2XX.DLL" ( _
    ByVal lngHandle As Integer, _
    ByRef lngModemStatus As Integer) As Integer 'Neu Kulraj

    Public lngModemStatus As Long
    Public Const FT_OPEN_BY_DESCRIPTION = 2
    Public FT_Description As String
    Public lngHandle As Integer
    Public FT_OK As Long = 0
    Public STE As Byte

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Hier(USB - Test)       'Testet Präsenz und Funktion des USB
        FT_Description = "EVAL232 Board USB <-> Serial" & Chr(0)            '
        FT_OK = FT_OpenByDescription(FT_Description, FT_OPEN_BY_DESCRIPTION, lngHandle)
        If FT_OK = 0 Then
            MsgBox("USB korrekt!", vbOKOnly, "RNARS Contest")
        Else : MsgBox("USB nicht OK...", vbOKOnly, "RNARS Contest")
        End If
        FT_OK = FT_Close(lngHandle)
        Me.STA.BackColor = Color.Black
    End Sub

    Private Sub EIN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EIN.Click
        FT_Description = Space(29)
        FT_Description = "EVAL232 Board USB <-> Serial" & Chr(0)
        FT_Description = Microsoft.VisualBasic.Left(FT_Description, InStr(1, FT_Description, vbNullChar) - 1)
        FT_OK = FT_OpenByDescription(FT_Description, 2, lngHandle)

        Me.STA.BackColor = Color.Green
        FT_OK = FT_SetRts(lngHandle)
        FT_OK = FT_SetDtr(lngHandle)
        Timer1.Enabled = True
        Timer1.Interval = 500
    End Sub

    Private Sub AUS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AUS.Click
        Me.STA.BackColor = Color.Black
        Timer1.Enabled = False
        FT_OK = FT_ClrRts(lngHandle)
        FT_OK = FT_ClrDtr(lngHandle)
        FT_OK = FT_Close(lngHandle)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Me.STA.BackColor = Color.Green Then
            Me.STA.BackColor = Color.Red
            FT_OK = FT_ClrDtr(lngHandle)
        Else
            Me.STA.BackColor = Color.Green
            FT_OK = FT_SetDtr(lngHandle)
        End If

        FT_OK = FT_ClrRts(lngHandle)
        FT_OK = FT_SetBreakOn(lngHandle)
        FT_OK = FT_GetModemStatus(lngHandle, lngModemStatus)
        STE = (lngModemStatus And &H20) / &H20
        If STE = 1 Then
            Timer1.Enabled = False
            Me.STA.BackColor = Color.Black
            FT_OK = FT_ClrDtr(lngHandle)
            FT_OK = FT_Close(lngHandle)
        End If
    End Sub
End Class